#BEGIN

#===========================================================================
# UU   UU LL     RRRRR   II   CCCCC  HH  HH   CCCCCCC  (c) 2004
# UU   UU LL     RR  RR  II  CC	     HH  HH  CCC
# UU   UU LL     RRRRR   II  CC	     HHHHHH  CC	  Christian Ulrich (UlrichC)
# UU   UU LL     RR RR   II  CC	     HH  HH  CC	   URL:http://www.UlrichC.de
# UU   UU LL     RR  RR  II  CC	     HH  HH  CCC
#   UUU   LLLLLL RR   RR II   CCCCC  HH  HH   CCCCCCC  eMail:Info@UlrichC.de
#===========================================================================
# BRUT-DECRYPT-MODUL alias decrypt_htpasswd.pl Version 1.00
#---------------------------------------------------------------------------
# COPYRIGHTS
#   This source code of http://www.ulrichc.de/ is licensed under the GNU/GPL
#
#   You can redistribute it and/or modify it under the terms of the
#   GNU General Public License as published by the Free Software Foundation;
#   either version 2 of the License, or (at your option) any later version.
#   See http://www.gnu.org/
#
#  Author:Christian Ulrich,(Germany)76448 Durmersheim Lk Rastatt,12.02.2004
#===========================================================================

#===========================================================================
# DECRIPTION
#---------------------------------------------------------------------------
# decode c DES Encryption from htpasswd
#
# example to use:
# change "test:XXF2OrGyU2fzk" below
# to your string and execute script
#===========================================================================

#####
# BRUT-DECRYPT-MODUL System requirements
use strict;

#####
# BRUT-DECRYPT-CU-MODULE requirements

#===========================================================================
# BRUT-DECRYPT-MODUL VARIABLES
#===========================================================================

my $htaccessString = "test:XXF2OrGyU2fzk";
my @_checkChars = &getCheckCharArray();

# ===================== selftest =======================
# name = test
# password = test
# salt = XX
#$htaccessString = "test:XXF2OrGyU2fzk";
#@_checkChars = split(//,"test");
# ===================== selftest =======================

my $_charCount = scalar(@_checkChars);
my ($_name,$_salt,$_cryptPasswd) = &decodeHtPasswdSring($htaccessString);
printf ("salt:$_salt -name:$_name\n");

my $_currentDigitCount = 1;
my @_charCursor = ();
my $_countCheck = 0;
my $_maxPassDigits = 256;

#===========================================================================
# BRUT-DECRYPT-MODUL FUNCTIONS (NO CHANGE THIS SECTION)
#===========================================================================

&startDecrypt();
sub startDecrypt
{
	if($htaccessString eq ""){
		print("Nothing to do :-(\n");
		exit(0);
	}
	
	my $paterns = "";
	while($_currentDigitCount <= $_maxPassDigits){
		for(my $p = 0; $p <= $_currentDigitCount-1; $p++){
			$paterns .= $_checkChars[$_charCursor[$p]];
		}
		print "check $paterns\n";
		if(&checkResult($paterns)){
			print("Password for $_name is ->$paterns<-\n");
			print("required checks are :$_countCheck\n");
			exit(0);
		}
		&resetDigitPositions();
		$_countCheck++;
		$paterns = "";
	}
}

sub resetDigitPositions
{
	for(my $d = $_currentDigitCount-1; $d >= 0 ;$d--){
		if($_charCursor[$d] < $_charCount-1){
			$_charCursor[$d]++;
			return;
		}
		else{
			$_charCursor[$d] = 0;
		}
	}
	$_currentDigitCount++;
}

sub checkResult
{
	if($_cryptPasswd eq crypt(shift,$_salt)){
		return 1;
	}
	return 0;
}

sub getCheckCharArray
{
	my ($vSpecialChars) = $_[0];
	my $chars = "abcdefghijklmnopqrstuvwxyz";
	my @checkChars = split(//,lc $chars);
	push(@checkChars,split(//,uc $chars));
	push(@checkChars,split(//,"1234567890"));
	push(@checkChars,split(//,$vSpecialChars));
	return @checkChars;
}

#decode the htaccess passwd like "admin:XXF2OrGyU2fzk"
sub decodeHtPasswdSring
{
	my ($name,$passString) = split(/\:/,$_[0]);
	my $salt = substr($passString,0,2);
	return ($name,$salt,$passString);
}

#===========================================================================
# BRUT-DECRYPT-MODUL END OF SCRIPT
#===========================================================================
1;